%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                       %%
%% Copyright (C) 2013 Texas Instruments Incorporated - http://www.ti.com %%
%%                                                                       %%
%% Author: Felipe Balbi <balbi@ti.com>                                   %%
%%                                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\chapter{The Sprint}
\label{chap:the-sprint}

\paragraph{}
The \textit{basic unit of development in Scrum}\cite{wikipediascrum} whose
duration is pre-defined. All sprints have the same duration, usually between
one week and one month.

\paragraph{}
In section \ref{sec:sprint-duration} we shall discuss about Sprint Duration and
what is Linux Core Product Development's accepted duration. In the following
section \ref{sec:sprint-process} we shall expose Scrum's development process and
discuss how to handle an iterative development model while developing Linux
Kernel code.

\paragraph{}
By the end of this chapter, we should have enough grounds to discuss about how
to successfully break backlog entries into bite-sized pieces in chapter
\ref{chap:work-breakdown}, how to come up with proper estimations in chapter
\ref{chap:estimating} and finally come up with our definition of done in
chapter \ref{chap:definition-of-done}.

\section{Sprint Duration}
\label{sec:sprint-duration}

\paragraph{}
Linux Core Product Development team will use a sprint duration of 2 weeks with
no exceptions. This is the most common choice for beginners in Agile practices
and, in particular, Scrum.

\paragraph{}
A 2-week sprint brings two clear benefits:

\begin{enumerate}
	\item It's a short amount of time.\label{item:short-amount-of-time}
	\item It's not as short as to cause too few story points to be taken
		in a given sprint.\label{item:not-too-short}
\end{enumerate}

\paragraph{}
Due to item \ref{item:short-amount-of-time}, risk management becomes easy. If
it turns out a particular sprint isn't successful, we're not loosing a
considerable amount of work --  only 2 weeks -- and we can easily fix that on
the next sprint.  A 2 week duration also allows a reasonable response time
to changing priorities in the backlog such as customer issues.

\paragraph{}
Item \ref{item:not-too-short}, on the other hand, makes it easier to see
progress. Even though we are focussing on time-boxing our sprints and making
them small enough as to decrease risks, we can still have a considerable amount
of new features finished by the end of the sprint which, in turn, gives us the
opportunity of coming up with good demos.

\section{Sprint Process}
\label{sec:sprint-process}

\paragraph{}
Figure \ref{fig:scrum-process} shows Scrum's overall process. Note that
development is performed in a set of continuous feedback loops.

\begin{figure}[ht]
	\centering
	\includegraphics[width=0.8\textwidth]{images/scrum-process.png}
	\caption{Scrum Process}
	\label{fig:scrum-process}
\end{figure}

\paragraph{}
There a few things to note here. First, when product backlog feeds sprint
backlogs, they become small, self-contained, estimated tasks which, can be
finished in the course of one day. This means that on each and every daily
scrum meeting, \textbf{ideally}, everybody should have an update. Clearly this
won't always be the case as problems arise.

\paragraph{}
Second, there are two loops that are carried over during a Sprint development
effort. The bigger loop is the sprint loop which, in our case, as we shall see,
will take 2 weeks. The smaller, and perhaps more important, loop is the daily
scrum.

\paragraph{}
The daily scrum -- that is, the daily 15 minutes meetings --, is of utmost
importance for the success of any Scrum development team. It gives developers
and managers visibility which hasn't been possible before. Such visibility
leads to roadblocks being solved much quicker which, in turn, leads to
development flowing smoothly towards the end product.  This meeting is
discussed in more detail in chapter \ref{chap:meetings}.

\paragraph{}
Third, after each Sprint there should be a \textbf{working} increment of the
software. The bold face in \textit{working} was purposeful. We can only deliver
working software inside of Scrum; or at least that will always be the target.

\paragraph{}
But how can anyone be sure that software is working before customer has access
to it? The answer to that question lies in methodical and (hopefully)
automated testing. Each task in Scrum should be tied to a companion testcase
proving that software fails before implementing that task and passes after the
fact.

\paragraph{}
The test case and code/scripts and documentation used to run that test case
are artifacts of the sprint and should be delivered to the system test team
for integration into the automated test system.  This is refere to in chapter
\ref{chap:definition-of-done} as part of the definition of done.
